<?php
namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\Model\Util\NovoCodigo;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class ModoDivulgController extends SMCrud {
    protected $dataSourceName = 'mododivulg';
    
    public function __construct ($crudService, $environment, $entityManager){
        parent::__construct($crudService, $environment);
        $this->entityManager = $entityManager;
        $this->connection    = $entityManager->getConnection();

    }
    
    public function setModoDivulg(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            foreach ($request->getDataSet()->getRows() as &$row) {
                
                if (array_key_exists('CDMODODIVULG', $row)) {
                    if ($row['__is_new']) {
                        $row['CDMODODIVULG'] = NovoCodigo::geraCodigo($row['NRORG'], "CDMODODIVULG", 1, 5, false, true);
                    }
                } else {
                    $row['CDMODODIVULG'] = NovoCodigo::geraCodigo($row['NRORG'], "CDMODODIVULG", 1, 5, false, true);
                }
            
            }
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
}