<?php

namespace Teknisa\SM\Service;

use Teknisa\SM\Factory\ValidacoesParametrosFaturamentoFactory;

class ValidacoesParametrosFaturamentoService {
    
    protected $factory;
    
    public function __construct(ValidacoesParametrosFaturamentoFactory $validacoesParametrosFaturamentoFactory) {
        $this->factory = $validacoesParametrosFaturamentoFactory;
    }
    
    /**
     * Retorna true se existir registro para o período informado, false se não existir.
     */
    public function validarSePeriodoDeCompetenciaExiste($nomeTabela, $nomeCampoPK, $valorCampoPK, $nomeCampoPai, $valorCampoPai, $diaini, $diafin, $nrorg) {
        $params = array(
            "DIAINI"          => $diaini,
            "DIAFIN"          => $diafin,
            "VALOR_CAMPO_PK"  => $valorCampoPK,
            "VALOR_CAMPO_PAI" => $valorCampoPai,
            "NRORG"           => $nrorg
        );
        
        $dataset = $this->factory->validarSePeriodoDeCompetenciaExiste($nomeTabela, $nomeCampoPK, $nomeCampoPai, $params);
        return (int)$dataset[0]["EXISTE"] > 0;
    }
}

?>