<?php

namespace Teknisa\SM\Util\Procedure;

use Doctrine\DBAL\Connection;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class FctCopiaVersionaContrato {
    
    const NOME = "FCT_COPIA_VERSIONA_CONTRATO";
    private $connection;
    
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
    
    /**
     * Executa a procedure.
     * 
     * @param integer $nrorg
     * @param string $idorcacontr
     * @param integer $nrseq
     * 
     * @return string
     */
    public function executar($nrseqcontrato, $idCopiaVersiona, $operador, $nrorg, $adcAgrupamento, $idParcelaConsiderada, $idReplicarNegociacao, $dtRenegociaCont) {
        $procedure = new StoredProcedure($this->connection, self::NOME);
        
        $procedure->addParam(new Param("P_NRSEQCONTRATO",         Param::PARAM_INPUT,  $nrseqcontrato,        Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_TIPO",                  Param::PARAM_INPUT,  $idCopiaVersiona,      Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_OPERADOR",              Param::PARAM_INPUT,  $operador,             Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_NRORG",                 Param::PARAM_INPUT,  $nrorg,                Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_NRSEQCONTRATO_GERADO",  Param::PARAM_OUTPUT, null,                  Param::PARAM_TYPE_INT, 20));
        $procedure->addParam(new Param("P_ADCAGRUPAMENTO",        Param::PARAM_INPUT,  $adcAgrupamento,       Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_IDPARCELACONSIDERADA",  Param::PARAM_INPUT,  $idParcelaConsiderada, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_IDREPLICARNEGOCIACAO",  Param::PARAM_INPUT,  $idReplicarNegociacao, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_DTRENEGOCIACONT",       Param::PARAM_INPUT,  $dtRenegociaCont,      Param::PARAM_TYPE_STR));                
                        
        $resultado = $procedure->execute();
        return (int)$resultado["P_NRSEQCONTRATO_GERADO"];
    }
    
}

?>